.386

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE

WinMain PROTO :DWORD, :DWORD, :DWORD, :DWORD

INCLUDE    \masm32\include\windows.inc
INCLUDE    \masm32\include\user32.inc
INCLUDE    \masm32\include\kernel32.inc
INCLUDELIB \masm32\lib\user32.lib
INCLUDELIB \masm32\lib\kernel32.lib

.DATA

ClassName       DB "SimpleWinClass",0
AppName         DB "Nasze pierwsze okno",0
MenuName        DB "FirstMenu",0
ButtonClassName DB "button",0
ButtonText      DB "Nasz pierwszy przycisk",0
EditClassName   DB "edit",0
TestString      DB "Och! Jestem w edytorze",0

.DATA?

hInstance   HINSTANCE ?
CommandLine LPSTR     ?
hwndButton  HWND      ?
hwndEdit    HWND      ?
buffer      DB 512 DUP(?)

.CONST

ButtonID    EQU 1
EditID      EQU 2
IDM_HELLO   EQU 1
IDM_CLEAR   EQU 2
IDM_GETTEXT EQU 3
IDM_EXIT    EQU 4

.CODE

start:
    INVOKE GetModuleHandle, NULL
    mov    hInstance, eax
    INVOKE GetCommandLine
    mov    CommandLine, eax
    INVOKE WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
    INVOKE ExitProcess, eax
    
WinMain PROC hInst:     HINSTANCE,\
             hPrevInst: HINSTANCE,\
             CmdLine:   LPSTR,\
             CmdShow:   DWORD

LOCAL wc:   WNDCLASSEX
LOCAL msg:  MSG
LOCAL hwnd: HWND

    mov    wc.cbSize, SIZEOF WNDCLASSEX
    mov    wc.style, CS_HREDRAW OR CS_VREDRAW
    mov    wc.lpfnWndProc, OFFSET WndProc
    mov    wc.cbClsExtra, NULL
    mov    wc.cbWndExtra, NULL
    push   hInst
    pop    wc.hInstance
    mov    wc.hbrBackground, COLOR_BTNFACE+1
    mov    wc.lpszMenuName, OFFSET MenuName
    mov    wc.lpszClassName, OFFSET ClassName
    INVOKE LoadIcon, NULL, IDI_APPLICATION
    mov    wc.hIcon, eax
    mov    wc.hIconSm, eax
    INVOKE LoadCursor, NULL, IDC_ARROW
    mov    wc.hCursor, eax
    INVOKE RegisterClassEx, ADDR wc
    INVOKE CreateWindowEx, WS_EX_CLIENTEDGE,\
                           ADDR ClassName, ADDR AppName,\
                           WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,\
                           CW_USEDEFAULT, 300, 200, NULL, NULL,\
                           hInst, NULL
    mov   hwnd, eax
    INVOKE ShowWindow, hwnd, SW_SHOWNORMAL
    INVOKE UpdateWindow, hwnd
    .WHILE TRUE
        INVOKE GetMessage, ADDR msg, NULL, 0, 0
        .BREAK .IF (!eax)
        INVOKE TranslateMessage, ADDR msg
        INVOKE DispatchMessage, ADDR msg
    .ENDW

    mov eax, msg.wParam
    ret
    
WinMain ENDP

WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    .IF uMsg==WM_DESTROY
        INVOKE PostQuitMessage, NULL
    .ELSEIF uMsg==WM_CREATE
        INVOKE CreateWindowEx, WS_EX_CLIENTEDGE,\
                               ADDR EditClassName, NULL,\
                               WS_CHILD OR WS_VISIBLE OR\
                               WS_BORDER OR ES_LEFT OR\
                               ES_AUTOHSCROLL,\
                               50, 35, 200, 25, hWnd,\
                               EditID, hInstance, NULL
        mov    hwndEdit, eax
        INVOKE SetFocus, hwndEdit
        INVOKE CreateWindowEx, NULL,\
                               ADDR ButtonClassName, ADDR ButtonText,\
                               WS_CHILD OR WS_VISIBLE OR BS_DEFPUSHBUTTON,\
                               50, 70, 200, 25, hWnd, ButtonID,\
                               hInstance, NULL
        mov    hwndButton, eax
    .ELSEIF uMsg==WM_COMMAND
        mov eax, wParam
        .IF lParam==0
            .IF ax==IDM_HELLO
                INVOKE SetWindowText, hwndEdit, ADDR TestString
                INVOKE SendMessage, hwndEdit, WM_KEYDOWN, VK_END, NULL
            .ELSEIF ax==IDM_CLEAR
                INVOKE SetWindowText, hwndEdit, NULL
            .ELSEIF  ax==IDM_GETTEXT
                INVOKE GetWindowText, hwndEdit, ADDR buffer, 512
                INVOKE MessageBox, NULL, ADDR buffer, ADDR AppName, MB_OK
            .ELSE
                INVOKE DestroyWindow, hWnd
            .ENDIF
        .ELSE
            .IF ax==ButtonID
                shr eax, 16
                .IF ax==BN_CLICKED
                    INVOKE SendMessage, hWnd, WM_COMMAND, IDM_GETTEXT, 0
                .ENDIF
            .ENDIF
        .ENDIF
    .ELSE
        INVOKE DefWindowProc, hWnd, uMsg, wParam, lParam
        ret
    .ENDIF
    xor eax, eax
    ret
    
WndProc ENDP

END start
